app-emulation/wine-d3d9: Sync from ::wine
authorNP-Hardass <NP-Hardass@gentoo.org>
Sat, 20 Jan 2018 07:50:07 +0000 (02:50 -0500)
committerNP-Hardass <NP-Hardass@gentoo.org>
Sat, 20 Jan 2018 08:00:31 +0000 (03:00 -0500)
Add 2.20, 2.21
Fix manpage generation

Closes: https://bugs.gentoo.org/617864
Package-Manager: Portage-2.3.19, Repoman-2.3.6

app-emulation/wine-d3d9/Manifest
app-emulation/wine-d3d9/wine-d3d9-2.0-r1.ebuild
app-emulation/wine-d3d9/wine-d3d9-2.17-r1.ebuild
app-emulation/wine-d3d9/wine-d3d9-2.18.ebuild
app-emulation/wine-d3d9/wine-d3d9-2.19.ebuild
app-emulation/wine-d3d9/wine-d3d9-2.20.ebuild [new file with mode: 0644]
app-emulation/wine-d3d9/wine-d3d9-2.21.ebuild [new file with mode: 0644]
app-emulation/wine-d3d9/wine-d3d9-9999.ebuild

index cb7d8c71e6f357b5d4d9ee55abdfe2d91db8361e..b3cf970fc56a2e0b1cd5567e39a3bac8f2ae5882 100644 (file)
@@ -1,9 +1,13 @@
-DIST gentoo-wine-patches-20170830.tar.xz 58456 BLAKE2B 86445a6d91d9981d069ff2fb3b64a47e166c76b4721ef877c74cd60e359ee5bdbe36ebf37cf796a18e9cf42dbc69ce1496777144fc28b072f47c965173bf48b4 SHA512 5e5159e3252b246bba0ef7fdba345db3ab1071c5b8b8b625f98eda18779d4024c5b76bdbf49ce7bd5c6b01b422807adf76820beddb2b4a6ee9e67d13052cc575
+DIST gentoo-wine-patches-20180119.tar.xz 58688 BLAKE2B e7d44906f3c81c69fd3016ac6a7e2b8e68cc82762cc0a6b469e572d9b2edfd04ce9353e151c07dac11f82b1d108517fc86862d724e83ee8c4e938d64f3f9b934 SHA512 3e605bf613dca333e501b5578d9c92a42d351a23f8d7d9d6a545a7dc043dcc4c7f52918e6ad46db63a6f00f3ace4b77055f8343176afb976e6a04590dcee64b7
 DIST wine-2.0.tar.bz2 23662707 BLAKE2B 1d485c1359ce8a0395a9f6378c1f8be33ea2836b80390d1eb1095057a0acedd21708daab16e1851a315391b9f9b0a360879b9d98c73bcc8371c5023e9a8037f5 SHA512 b0a57ba8202d9fc396e5bfb7a7718d6bababbed8f3351e7fdc36afa37f35a871e04903757618f73427aeb71a52b2d323977d79e48f8b38d636f23fd404441186
 DIST wine-2.17.tar.xz 19505528 BLAKE2B 5b4b0c708fb4c5bb7367ad87fd4438b75fbe84fa4fb0f4514aa816de771f91f38dc76da80410fa25711b060c26d95127c49d2ce0db613e3560a04d7bf2bff4f7 SHA512 cb10c876e689aa601c68673aab32c0514dd174692a01bdb3afc78d5e6079b0e77f48783af2f54245f397c762da3b4e5f2c1d39d2ce7fdb3b117d338b95c24810
 DIST wine-2.18.tar.xz 19546360 BLAKE2B 711b1396160b325a3021f066cc80eda0e2eb69c46ab671c6a4d1f417d0c2439e53854d37fee8507296386d1a828484af93e833f6c08413fd2571c03477e97386 SHA512 61cc39fa3d2b0a0ab3c5d17579865e6aea76dd9513a4b3c45975a2d5c05f2b4ba952b97eef547131a014763c7f692a08df29bc2ebf7e4ac7e2616e6a7822ddb9
 DIST wine-2.19.tar.xz 19549464 BLAKE2B 86d130cc43d7d674d2f478365952962b2792fd585b8d074564108bc7e9f4f7690337e4758b9a24e54fe8fd60187d3a96496a5ffc454ba674b02ecdde68efd3bb SHA512 83558231bdc592b1f69cfedf6c689063df7bd9fecdfafba6fb7f6a2c7fa7783973efb85a6a49305afc18b1aa268209ee5b9c0655756e05d7550468698dfa51ae
+DIST wine-2.20.tar.xz 19597556 BLAKE2B 80a9886fa77e5788b143521288f7d83c92754610c9426e58c759d2c33767bd23f7d2a44a17ceeec0bfe9065264393e0aa1087a0827ea7d438ffd938ba2eb2fb5 SHA512 d8d374d1e690ce9d3964fc81054fb7f4cd56cbae6bc44ebbf80b7dc7f04524baa2bd831e0be8f00de4cb0e14c1cb71780d424f5dcb9851fcaed9fb22f5ce5d23
+DIST wine-2.21.tar.xz 19620888 BLAKE2B 26d19c5805db58b53530b80eda3ab229f7961542d398cb0e74155e5341de8b484d301c263653ae50e953588538f6782a9b2200b822ba66f091e65d259e07db8e SHA512 4e33c463debe637827ed65f1118e692832bb5374491f706f9d251b8a2956e20d2df5d90ceba218b9bc9e946de91b8ba1d96b460453f59cdd9d82f070d07e0c43
 DIST wine-d3d9-2.0.tar.gz 48373 BLAKE2B 80370a7519141030a7e54c2ea5db410b2bf1cde8d8389618487c52e4ff40f87cf7b0f9087331bb43fa6436e1b9936de9cc00a02b9ab9ce6528635a245e6a8b3f SHA512 a9e2d1c9f2784128e4c53a8dc923070a5057b5ff3d83c2b536a2d2df0bc8433ac92b8ab1c3cdf34158c0e7bfe497ddb5974605fbc1736a92307639d59450c7a1
 DIST wine-d3d9-2.17.tar.gz 48722 BLAKE2B fa226943210349feb1b906233010fe874b28caf385fca6749a84903c5eba2ed7303a6a7b0e2a15dfe20af399ec9d755ad7ed71c18248018d3968c1e1bcc44951 SHA512 530d44a968a68e06449da2286b8c9740a80b681ff610f6ddc87e6fb569e6c29181341266a04238965a7bfc209e20c1521847b70daa8d3532c2a269db0d200154
 DIST wine-d3d9-2.18.tar.gz 48722 BLAKE2B 47bfd1514cf135b84be7b2a9843e3125acae6f7f817443730498739290503921f998455e1e093ad15c4ac68e020af447add9dfdc4385cbc9bf7af6f3143583f5 SHA512 0e66c51e1957b27ccb9f326b0aaf2b0d09b7bbc9d03e1d321aa1789d2560b8e60fd83c4e86999d96a03aa73a37c96f34d93245763969a314150900741aa03933
 DIST wine-d3d9-2.19.tar.gz 48818 BLAKE2B b053ee0ad798a7d8ad53b3daff1757caaa52f095435f2fb89893c7313d490a2359217a5638529e918a1446f13533a746836c1c22218cba875a1420816618408a SHA512 be43435cd53f367ca57080c08218db302a90bf85ec6e917e89375904c456b585b61fb6053f9b4366b7e844f8246cabe83460a9866f614dbb5df3edfb43b2f54a
+DIST wine-d3d9-2.20.tar.gz 48822 BLAKE2B b9ae137e05f672990707aa3ae88aa569a517e644579ff545b35393074ca03ac0c6aaea7494a90a4f6c4278f7397e1e5078e90383f5debeb4edfe46c8834446ff SHA512 f1fa4882514d0bbb77a7244448a9153cddd5029fca49c5221783fafc13f30888b606c6be4417ecdf85bd80a659ecf54c57ea5aedd49acb87cdc9b42d98f68dc0
+DIST wine-d3d9-2.21.tar.gz 48813 BLAKE2B a83b558682f19a44f62c33c8782f4415250c537373654b36c4b1aa6e078ed09594ec1f0e5b76093d88b835786dac96047a1584aa94953256d6ca2804e08ec3df SHA512 64edab41be95adb1dc81c040b13901fbc7fd54467e1306639e3d459c41521d61ebf09e7028688166af8fd0f238063e125d8985a4fc66b185fade996ed596bb2a
index b254fbff8045338ddf6fd2a372ae89a76152100d..3f8f0715fe4777b2df5bcfc0a4e6219ab0a3b063 100644 (file)
@@ -26,7 +26,7 @@ S="${WORKDIR}/${MY_P}"
 
 D3D9_P="wine-d3d9-${PV}"
 D3D9_DIR="${WORKDIR}/wine-d3d9-patches-${D3D9_P}"
-GWP_V="20170830"
+GWP_V="20180119"
 PATCHDIR="${WORKDIR}/gentoo-wine-patches"
 
 DESCRIPTION="Free implementation of Windows(tm) on Unix, with Gallium Nine patchset"
@@ -169,9 +169,10 @@ PATCHES=(
        "${PATCHDIR}/patches/${MY_PN}-1.5.26-winegcc.patch" #260726
        "${PATCHDIR}/patches/${MY_PN}-1.9.5-multilib-portage.patch" #395615
        "${PATCHDIR}/patches/${MY_PN}-1.6-memset-O3.patch" #480508
-       "${PATCHDIR}/patches/${MY_PN}-2.0-multislot-apploader.patch"
+       "${PATCHDIR}/patches/${MY_PN}-2.0-multislot-apploader.patch" #310611
        "${PATCHDIR}/patches/freetype-2.8.1-segfault.patch" #631676
        "${PATCHDIR}/patches/freetype-2.8.1-drop-glyphs.patch" #631376
+       "${PATCHDIR}/patches/${MY_PN}-2.0-prevent-build-of-localized-manpages.patch" #469418 #617864
 )
 PATCHES_BIN=(
        "${PATCHDIR}/patches/freetype-2.8.1-patch-fonts.patch" #631376
@@ -370,6 +371,31 @@ src_prepare() {
        cp "${PATCHDIR}/files/oic_winlogo.ico" dlls/user32/resources/ || die
 
        l10n_get_locales > po/LINGUAS || die # otherwise wine doesn't respect LINGUAS
+
+       # Fix manpage generation for locales #469418 and abi_x86_64 #617864
+       # Depends on wine-2.0-prevent-build-of-localized-manpages.patch"
+       # Duplicate manpages input for wine64
+       local man
+       for man in loader/*.man.in; do
+               cp ${man} ${man/wine/wine64} || die
+       done
+       # Add in proper manpages to Makefile
+       local search_text="wine.man.in"
+       if use abi_x86_64; then
+               sed -i "/${search_text}/i \
+                       "$'\\\t'"wine64.man.in "$'\\\\' loader/Makefile.in || die
+       fi
+       local l
+       for l in de fr pl; do
+               if has ${l} ${LINGUAS-${l}}; then
+                       sed -i "/${search_text}/i \
+                               "$'\\\t'"wine.${l}.UTF-8.man.in "$'\\\\' loader/Makefile.in || die
+                       if use abi_x86_64; then
+                               sed -i "/${search_text}/i \
+                                       "$'\\\t'"wine64.${l}.UTF-8.man.in "$'\\\\' loader/Makefile.in || die
+                       fi
+               fi
+       done
 }
 
 src_configure() {
@@ -514,14 +540,6 @@ multilib_src_install_all() {
        for b in "${D%/}${MY_PREFIX}"/bin/*; do
                make_wrapper "${b##*/}-${WINE_VARIANT}" "${MY_PREFIX}/bin/${b##*/}"
        done
-
-       # respect LINGUAS when installing man pages, #469418
-       local l
-       for l in de fr pl; do
-               has ${l} ${LINGUAS-${l}} || rm -rf "${D%/}${MY_MANDIR}"/${l}*
-       done
-
-       eval "${glob_state}"
 }
 
 pkg_postinst() {
index 7353ee3ac22ca7cdce9b56b053073a8d761532f2..63b5cb6bc73674247896a46090680f126faea150 100644 (file)
@@ -26,7 +26,7 @@ S="${WORKDIR}/${MY_P}"
 
 D3D9_P="wine-d3d9-${PV}"
 D3D9_DIR="${WORKDIR}/wine-d3d9-patches-${D3D9_P}"
-GWP_V="20170830"
+GWP_V="20180119"
 PATCHDIR="${WORKDIR}/gentoo-wine-patches"
 
 DESCRIPTION="Free implementation of Windows(tm) on Unix, with Gallium Nine patchset"
@@ -170,9 +170,10 @@ PATCHES=(
        "${PATCHDIR}/patches/${MY_PN}-1.5.26-winegcc.patch" #260726
        "${PATCHDIR}/patches/${MY_PN}-1.9.5-multilib-portage.patch" #395615
        "${PATCHDIR}/patches/${MY_PN}-1.6-memset-O3.patch" #480508
-       "${PATCHDIR}/patches/${MY_PN}-2.0-multislot-apploader.patch"
+       "${PATCHDIR}/patches/${MY_PN}-2.0-multislot-apploader.patch" #310611
        "${PATCHDIR}/patches/freetype-2.8.1-segfault.patch" #631676
        "${PATCHDIR}/patches/freetype-2.8.1-drop-glyphs.patch" #631376
+       "${PATCHDIR}/patches/${MY_PN}-2.0-prevent-build-of-localized-manpages.patch" #469418 #617864
 )
 PATCHES_BIN=(
        "${PATCHDIR}/patches/freetype-2.8.1-patch-fonts.patch" #631376
@@ -371,6 +372,31 @@ src_prepare() {
        cp "${PATCHDIR}/files/oic_winlogo.ico" dlls/user32/resources/ || die
 
        l10n_get_locales > po/LINGUAS || die # otherwise wine doesn't respect LINGUAS
+
+       # Fix manpage generation for locales #469418 and abi_x86_64 #617864
+       # Depends on wine-2.0-prevent-build-of-localized-manpages.patch"
+       # Duplicate manpages input for wine64
+       local man
+       for man in loader/*.man.in; do
+               cp ${man} ${man/wine/wine64} || die
+       done
+       # Add in proper manpages to Makefile
+       local search_text="wine.man.in"
+       if use abi_x86_64; then
+               sed -i "/${search_text}/i \
+                       "$'\\\t'"wine64.man.in "$'\\\\' loader/Makefile.in || die
+       fi
+       local l
+       for l in de fr pl; do
+               if has ${l} ${LINGUAS-${l}}; then
+                       sed -i "/${search_text}/i \
+                               "$'\\\t'"wine.${l}.UTF-8.man.in "$'\\\\' loader/Makefile.in || die
+                       if use abi_x86_64; then
+                               sed -i "/${search_text}/i \
+                                       "$'\\\t'"wine64.${l}.UTF-8.man.in "$'\\\\' loader/Makefile.in || die
+                       fi
+               fi
+       done
 }
 
 src_configure() {
@@ -516,14 +542,6 @@ multilib_src_install_all() {
        for b in "${D%/}${MY_PREFIX}"/bin/*; do
                make_wrapper "${b##*/}-${WINE_VARIANT}" "${MY_PREFIX}/bin/${b##*/}"
        done
-
-       # respect LINGUAS when installing man pages, #469418
-       local l
-       for l in de fr pl; do
-               has ${l} ${LINGUAS-${l}} || rm -rf "${D%/}${MY_MANDIR}"/${l}*
-       done
-
-       eval "${glob_state}"
 }
 
 pkg_postinst() {
index 27e42238117980ad4049abe48d9bae1b5c1dcca8..0df97c34f88dfa682b6e3ae73d36080a069aa07e 100644 (file)
@@ -26,7 +26,7 @@ S="${WORKDIR}/${MY_P}"
 
 D3D9_P="wine-d3d9-${PV}"
 D3D9_DIR="${WORKDIR}/wine-d3d9-patches-${D3D9_P}"
-GWP_V="20170830"
+GWP_V="20180119"
 PATCHDIR="${WORKDIR}/gentoo-wine-patches"
 
 DESCRIPTION="Free implementation of Windows(tm) on Unix, with Gallium Nine patchset"
@@ -170,7 +170,8 @@ PATCHES=(
        "${PATCHDIR}/patches/${MY_PN}-1.5.26-winegcc.patch" #260726
        "${PATCHDIR}/patches/${MY_PN}-1.9.5-multilib-portage.patch" #395615
        "${PATCHDIR}/patches/${MY_PN}-1.6-memset-O3.patch" #480508
-       "${PATCHDIR}/patches/${MY_PN}-2.0-multislot-apploader.patch"
+       "${PATCHDIR}/patches/${MY_PN}-2.0-multislot-apploader.patch" #310611
+       "${PATCHDIR}/patches/${MY_PN}-2.0-prevent-build-of-localized-manpages.patch" #469418 #617864
 )
 PATCHES_BIN=()
 
@@ -367,6 +368,31 @@ src_prepare() {
        cp "${PATCHDIR}/files/oic_winlogo.ico" dlls/user32/resources/ || die
 
        l10n_get_locales > po/LINGUAS || die # otherwise wine doesn't respect LINGUAS
+
+       # Fix manpage generation for locales #469418 and abi_x86_64 #617864
+       # Depends on wine-2.0-prevent-build-of-localized-manpages.patch"
+       # Duplicate manpages input for wine64
+       local man
+       for man in loader/*.man.in; do
+               cp ${man} ${man/wine/wine64} || die
+       done
+       # Add in proper manpages to Makefile
+       local search_text="wine.man.in"
+       if use abi_x86_64; then
+               sed -i "/${search_text}/i \
+                       "$'\\\t'"wine64.man.in "$'\\\\' loader/Makefile.in || die
+       fi
+       local l
+       for l in de fr pl; do
+               if has ${l} ${LINGUAS-${l}}; then
+                       sed -i "/${search_text}/i \
+                               "$'\\\t'"wine.${l}.UTF-8.man.in "$'\\\\' loader/Makefile.in || die
+                       if use abi_x86_64; then
+                               sed -i "/${search_text}/i \
+                                       "$'\\\t'"wine64.${l}.UTF-8.man.in "$'\\\\' loader/Makefile.in || die
+                       fi
+               fi
+       done
 }
 
 src_configure() {
@@ -512,14 +538,6 @@ multilib_src_install_all() {
        for b in "${D%/}${MY_PREFIX}"/bin/*; do
                make_wrapper "${b##*/}-${WINE_VARIANT}" "${MY_PREFIX}/bin/${b##*/}"
        done
-
-       # respect LINGUAS when installing man pages, #469418
-       local l
-       for l in de fr pl; do
-               has ${l} ${LINGUAS-${l}} || rm -rf "${D%/}${MY_MANDIR}"/${l}*
-       done
-
-       eval "${glob_state}"
 }
 
 pkg_postinst() {
index 27e42238117980ad4049abe48d9bae1b5c1dcca8..0df97c34f88dfa682b6e3ae73d36080a069aa07e 100644 (file)
@@ -26,7 +26,7 @@ S="${WORKDIR}/${MY_P}"
 
 D3D9_P="wine-d3d9-${PV}"
 D3D9_DIR="${WORKDIR}/wine-d3d9-patches-${D3D9_P}"
-GWP_V="20170830"
+GWP_V="20180119"
 PATCHDIR="${WORKDIR}/gentoo-wine-patches"
 
 DESCRIPTION="Free implementation of Windows(tm) on Unix, with Gallium Nine patchset"
@@ -170,7 +170,8 @@ PATCHES=(
        "${PATCHDIR}/patches/${MY_PN}-1.5.26-winegcc.patch" #260726
        "${PATCHDIR}/patches/${MY_PN}-1.9.5-multilib-portage.patch" #395615
        "${PATCHDIR}/patches/${MY_PN}-1.6-memset-O3.patch" #480508
-       "${PATCHDIR}/patches/${MY_PN}-2.0-multislot-apploader.patch"
+       "${PATCHDIR}/patches/${MY_PN}-2.0-multislot-apploader.patch" #310611
+       "${PATCHDIR}/patches/${MY_PN}-2.0-prevent-build-of-localized-manpages.patch" #469418 #617864
 )
 PATCHES_BIN=()
 
@@ -367,6 +368,31 @@ src_prepare() {
        cp "${PATCHDIR}/files/oic_winlogo.ico" dlls/user32/resources/ || die
 
        l10n_get_locales > po/LINGUAS || die # otherwise wine doesn't respect LINGUAS
+
+       # Fix manpage generation for locales #469418 and abi_x86_64 #617864
+       # Depends on wine-2.0-prevent-build-of-localized-manpages.patch"
+       # Duplicate manpages input for wine64
+       local man
+       for man in loader/*.man.in; do
+               cp ${man} ${man/wine/wine64} || die
+       done
+       # Add in proper manpages to Makefile
+       local search_text="wine.man.in"
+       if use abi_x86_64; then
+               sed -i "/${search_text}/i \
+                       "$'\\\t'"wine64.man.in "$'\\\\' loader/Makefile.in || die
+       fi
+       local l
+       for l in de fr pl; do
+               if has ${l} ${LINGUAS-${l}}; then
+                       sed -i "/${search_text}/i \
+                               "$'\\\t'"wine.${l}.UTF-8.man.in "$'\\\\' loader/Makefile.in || die
+                       if use abi_x86_64; then
+                               sed -i "/${search_text}/i \
+                                       "$'\\\t'"wine64.${l}.UTF-8.man.in "$'\\\\' loader/Makefile.in || die
+                       fi
+               fi
+       done
 }
 
 src_configure() {
@@ -512,14 +538,6 @@ multilib_src_install_all() {
        for b in "${D%/}${MY_PREFIX}"/bin/*; do
                make_wrapper "${b##*/}-${WINE_VARIANT}" "${MY_PREFIX}/bin/${b##*/}"
        done
-
-       # respect LINGUAS when installing man pages, #469418
-       local l
-       for l in de fr pl; do
-               has ${l} ${LINGUAS-${l}} || rm -rf "${D%/}${MY_MANDIR}"/${l}*
-       done
-
-       eval "${glob_state}"
 }
 
 pkg_postinst() {
diff --git a/app-emulation/wine-d3d9/wine-d3d9-2.20.ebuild b/app-emulation/wine-d3d9/wine-d3d9-2.20.ebuild
new file mode 100644 (file)
index 0000000..7f16ff6
--- /dev/null
@@ -0,0 +1,588 @@
+# Copyright 1999-2018 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+PLOCALES="ar bg ca cs da de el en en_US eo es fa fi fr he hi hr hu it ja ko lt ml nb_NO nl or pa pl pt_BR pt_PT rm ro ru sk sl sr_RS@cyrillic sr_RS@latin sv te th tr uk wa zh_CN zh_TW"
+PLOCALE_BACKUP="en"
+
+inherit autotools eutils flag-o-matic gnome2-utils l10n multilib multilib-minimal pax-utils toolchain-funcs virtualx versionator xdg-utils
+
+MY_PN="${PN%%-*}"
+MY_P="${MY_PN}-${PV}"
+
+if [[ ${PV} == "9999" ]] ; then
+       EGIT_REPO_URI="https://source.winehq.org/git/wine.git"
+       EGIT_BRANCH="master"
+       inherit git-r3
+       SRC_URI=""
+       #KEYWORDS=""
+else
+       MAJOR_V=$(get_version_component_range 1)
+       SRC_URI="https://dl.winehq.org/wine/source/${MAJOR_V}.x/${MY_P}.tar.xz"
+       KEYWORDS="-* ~amd64 ~x86 ~x86-fbsd"
+fi
+S="${WORKDIR}/${MY_P}"
+
+D3D9_P="wine-d3d9-${PV}"
+D3D9_DIR="${WORKDIR}/wine-d3d9-patches-${D3D9_P}"
+GWP_V="20180119"
+PATCHDIR="${WORKDIR}/gentoo-wine-patches"
+
+DESCRIPTION="Free implementation of Windows(tm) on Unix, with Gallium Nine patchset"
+HOMEPAGE="https://www.winehq.org/"
+SRC_URI="${SRC_URI}
+       https://dev.gentoo.org/~np-hardass/distfiles/wine/gentoo-wine-patches-${GWP_V}.tar.xz
+"
+
+if [[ ${PV} == "9999" ]] ; then
+       D3D9_EGIT_REPO_URI="https://github.com/sarnex/wine-d3d9-patches.git"
+else
+       SRC_URI="${SRC_URI}
+       d3d9? ( https://github.com/sarnex/wine-d3d9-patches/archive/${D3D9_P}.tar.gz )"
+fi
+
+LICENSE="LGPL-2.1"
+SLOT="${PV}"
+IUSE="+abi_x86_32 +abi_x86_64 +alsa capi cups custom-cflags d3d9 dos elibc_glibc +fontconfig +gecko gphoto2 gsm gstreamer +jpeg kerberos kernel_FreeBSD +lcms ldap +mono mp3 ncurses netapi nls odbc openal opencl +opengl osmesa oss +perl pcap +png prelink pulseaudio +realtime +run-exes samba scanner selinux +ssl test +threads +truetype udev +udisks v4l +X +xcomposite xinerama +xml"
+REQUIRED_USE="|| ( abi_x86_32 abi_x86_64 )
+       X? ( truetype )
+       elibc_glibc? ( threads )
+       osmesa? ( opengl )
+       test? ( abi_x86_32 )" # osmesa-opengl #286560 # X-truetype #551124
+
+# FIXME: the test suite is unsuitable for us; many tests require net access
+# or fail due to Xvfb's opengl limitations.
+RESTRICT="test"
+
+COMMON_DEPEND="
+       X? (
+               x11-libs/libXcursor[${MULTILIB_USEDEP}]
+               x11-libs/libXext[${MULTILIB_USEDEP}]
+               x11-libs/libXfixes[${MULTILIB_USEDEP}]
+               x11-libs/libXrandr[${MULTILIB_USEDEP}]
+               x11-libs/libXi[${MULTILIB_USEDEP}]
+               x11-libs/libXxf86vm[${MULTILIB_USEDEP}]
+       )
+       alsa? ( media-libs/alsa-lib[${MULTILIB_USEDEP}] )
+       capi? ( net-libs/libcapi[${MULTILIB_USEDEP}] )
+       cups? ( net-print/cups:=[${MULTILIB_USEDEP}] )
+       d3d9? (
+               media-libs/mesa[d3d9,egl,${MULTILIB_USEDEP}]
+               x11-libs/libX11[${MULTILIB_USEDEP}]
+               x11-libs/libXext[${MULTILIB_USEDEP}]
+               x11-libs/libxcb[${MULTILIB_USEDEP}]
+       )
+       fontconfig? ( media-libs/fontconfig:=[${MULTILIB_USEDEP}] )
+       gphoto2? ( media-libs/libgphoto2:=[${MULTILIB_USEDEP}] )
+       gsm? ( media-sound/gsm:=[${MULTILIB_USEDEP}] )
+       gstreamer? (
+               media-libs/gstreamer:1.0[${MULTILIB_USEDEP}]
+               media-plugins/gst-plugins-meta:1.0[${MULTILIB_USEDEP}]
+       )
+       jpeg? ( virtual/jpeg:0=[${MULTILIB_USEDEP}] )
+       kerberos? ( virtual/krb5:0=[${MULTILIB_USEDEP}] )
+       lcms? ( media-libs/lcms:2=[${MULTILIB_USEDEP}] )
+       ldap? ( net-nds/openldap:=[${MULTILIB_USEDEP}] )
+       mp3? ( >=media-sound/mpg123-1.5.0[${MULTILIB_USEDEP}] )
+       ncurses? ( >=sys-libs/ncurses-5.2:0=[${MULTILIB_USEDEP}] )
+       netapi? ( net-fs/samba[netapi(+),${MULTILIB_USEDEP}] )
+       nls? ( sys-devel/gettext[${MULTILIB_USEDEP}] )
+       odbc? ( dev-db/unixODBC:=[${MULTILIB_USEDEP}] )
+       openal? ( media-libs/openal:=[${MULTILIB_USEDEP}] )
+       opencl? ( virtual/opencl[${MULTILIB_USEDEP}] )
+       opengl? (
+               virtual/glu[${MULTILIB_USEDEP}]
+               virtual/opengl[${MULTILIB_USEDEP}]
+       )
+       osmesa? ( >=media-libs/mesa-13[osmesa,${MULTILIB_USEDEP}] )
+       pcap? ( net-libs/libpcap[${MULTILIB_USEDEP}] )
+       png? ( media-libs/libpng:0=[${MULTILIB_USEDEP}] )
+       pulseaudio? ( media-sound/pulseaudio[${MULTILIB_USEDEP}] )
+       scanner? ( media-gfx/sane-backends:=[${MULTILIB_USEDEP}] )
+       ssl? ( net-libs/gnutls:=[${MULTILIB_USEDEP}] )
+       truetype? ( >=media-libs/freetype-2.0.0[${MULTILIB_USEDEP}] )
+       udev? ( virtual/libudev:=[${MULTILIB_USEDEP}] )
+       udisks? ( sys-apps/dbus[${MULTILIB_USEDEP}] )
+       v4l? ( media-libs/libv4l[${MULTILIB_USEDEP}] )
+       xcomposite? ( x11-libs/libXcomposite[${MULTILIB_USEDEP}] )
+       xinerama? ( x11-libs/libXinerama[${MULTILIB_USEDEP}] )
+       xml? (
+               dev-libs/libxml2[${MULTILIB_USEDEP}]
+               dev-libs/libxslt[${MULTILIB_USEDEP}]
+       )
+       abi_x86_32? (
+               !app-emulation/emul-linux-x86-baselibs[-abi_x86_32(-)]
+               !<app-emulation/emul-linux-x86-baselibs-20140508-r14
+               !app-emulation/emul-linux-x86-db[-abi_x86_32(-)]
+               !<app-emulation/emul-linux-x86-db-20140508-r3
+               !app-emulation/emul-linux-x86-medialibs[-abi_x86_32(-)]
+               !<app-emulation/emul-linux-x86-medialibs-20140508-r6
+               !app-emulation/emul-linux-x86-opengl[-abi_x86_32(-)]
+               !<app-emulation/emul-linux-x86-opengl-20140508-r1
+               !app-emulation/emul-linux-x86-sdl[-abi_x86_32(-)]
+               !<app-emulation/emul-linux-x86-sdl-20140508-r1
+               !app-emulation/emul-linux-x86-soundlibs[-abi_x86_32(-)]
+               !<app-emulation/emul-linux-x86-soundlibs-20140508
+               !app-emulation/emul-linux-x86-xlibs[-abi_x86_32(-)]
+               !<app-emulation/emul-linux-x86-xlibs-20140508
+       )"
+
+RDEPEND="${COMMON_DEPEND}
+       app-emulation/wine-desktop-common
+       >app-eselect/eselect-wine-0.3
+       !app-emulation/wine:0
+       dos? ( >=games-emulation/dosbox-0.74_p20160629 )
+       gecko? ( app-emulation/wine-gecko:2.47[abi_x86_32?,abi_x86_64?] )
+       mono? ( app-emulation/wine-mono:4.7.1 )
+       perl? (
+               dev-lang/perl
+               dev-perl/XML-Simple
+       )
+       pulseaudio? (
+               realtime? ( sys-auth/rtkit )
+       )
+       samba? ( >=net-fs/samba-3.0.25[winbind] )
+       selinux? ( sec-policy/selinux-wine )
+       udisks? ( sys-fs/udisks:2 )"
+
+# tools/make_requests requires perl
+DEPEND="${COMMON_DEPEND}
+       sys-devel/flex
+       >=sys-kernel/linux-headers-2.6
+       virtual/pkgconfig
+       virtual/yacc
+       X? (
+               x11-proto/inputproto
+               x11-proto/xextproto
+               x11-proto/xf86vidmodeproto
+       )
+       prelink? ( sys-devel/prelink )
+       xinerama? ( x11-proto/xineramaproto )"
+
+# These use a non-standard "Wine" category, which is provided by
+# /etc/xdg/applications-merged/wine.menu
+QA_DESKTOP_FILE="usr/share/applications/wine-browsedrive.desktop
+usr/share/applications/wine-notepad.desktop
+usr/share/applications/wine-uninstaller.desktop
+usr/share/applications/wine-winecfg.desktop"
+
+PATCHES=(
+       "${PATCHDIR}/patches/${MY_PN}-1.5.26-winegcc.patch" #260726
+       "${PATCHDIR}/patches/${MY_PN}-1.9.5-multilib-portage.patch" #395615
+       "${PATCHDIR}/patches/${MY_PN}-1.6-memset-O3.patch" #480508
+       "${PATCHDIR}/patches/${MY_PN}-2.0-multislot-apploader.patch" #310611
+       "${PATCHDIR}/patches/${MY_PN}-2.0-prevent-build-of-localized-manpages.patch" #469418 #617864
+)
+PATCHES_BIN=()
+
+# https://bugs.gentoo.org/show_bug.cgi?id=635222
+if [[ ${#PATCHES_BIN[@]} -ge 1 ]] || [[ ${PV} == 9999 ]]; then
+       DEPEND+=" dev-util/patchbin"
+fi
+
+wine_compiler_check() {
+       [[ ${MERGE_TYPE} = "binary" ]] && return 0
+
+       # GCC-specific bugs
+       if tc-is-gcc; then
+               # bug #549768
+               if use abi_x86_64 && [[ $(gcc-major-version) = 5 && $(gcc-minor-version) -le 2 ]]; then
+                       ebegin "Checking for gcc-5 ms_abi compiler bug"
+                       $(tc-getCC) -O2 "${PATCHDIR}/files/pr66838.c" -o "${T}"/pr66838 || die
+                       # Run in subshell to prevent "Aborted" message
+                       ( "${T}"/pr66838 || false ) >/dev/null 2>&1
+                       if ! eend $?; then
+                               eerror "64-bit wine cannot be built with gcc-5.1 or initial patchset of 5.2.0"
+                               eerror "due to compiler bugs; please re-emerge the latest gcc-5.2.x ebuild,"
+                               eerror "or use gcc-config to select a different compiler version."
+                               eerror "See https://bugs.gentoo.org/549768"
+                               eerror
+                               return 1
+                       fi
+               fi
+               # bug #574044
+               if use abi_x86_64 && [[ $(gcc-major-version) = 5 && $(gcc-minor-version) = 3 ]]; then
+                       ebegin "Checking for gcc-5-3 stack realignment compiler bug"
+                       # Compile in subshell to prevent "Aborted" message
+                       ( $(tc-getCC) -O2 -mincoming-stack-boundary=3 "${PATCHDIR}/files/pr69140.c" -o "${T}"/pr69140 ) >/dev/null 2>&1
+                       if ! eend $?; then
+                               eerror "Wine cannot be built with this version of gcc-5.3"
+                               eerror "due to compiler bugs; please re-emerge the latest gcc-5.3.x ebuild,"
+                               eerror "or use gcc-config to select a different compiler version."
+                               eerror "See https://bugs.gentoo.org/574044"
+                               eerror
+                               return 1
+                       fi
+               fi
+       fi
+
+       # Ensure compiler support
+       if use abi_x86_64; then
+               ebegin "Checking for 64-bit compiler with builtin_ms_va_list support"
+               # Compile in subshell to prevent "Aborted" message
+               ( $(tc-getCC) -O2 "${PATCHDIR}/files/builtin_ms_va_list.c" -o "${T}"/builtin_ms_va_list >/dev/null 2>&1)
+               if ! eend $?; then
+                       eerror "This version of $(tc-getCC) does not support builtin_ms_va_list, can't enable 64-bit wine"
+                       eerror
+                       eerror "You need gcc-4.4+ or clang 3.8+ to build 64-bit wine"
+                       eerror
+                       return 1
+               fi
+       fi
+}
+
+wine_build_environment_check() {
+       [[ ${MERGE_TYPE} = "binary" ]] && return 0
+
+       if use abi_x86_64; then
+               if tc-is-gcc && [[ $(gcc-major-version) -lt 4 || ( $(gcc-major-version) -eq 4 && $(gcc-minor-version) -lt 4 ) ]]; then
+                       eerror "You need gcc-4.4+ to compile 64-bit wine"
+                       die
+               elif tc-is-clang && [[ $(clang-major-version) -lt 3 || ( $(clang-major-version) -eq 3 && $(clang-minor-version) -lt 8 ) ]]; then
+                       eerror "You need clang-3.8+ to compile 64-bit wine"
+                       die
+               fi
+       fi
+       if tc-is-gcc && [[ $(gcc-major-version) -eq 5 && $(gcc-minor-version) -le 3 ]]; then
+               ewarn "GCC-5.0-5.3 suffered from compiler bugs and are no longer supported by"
+               ewarn "Gentoo's Toolchain Team. If your ebuild fails the compiler checks in"
+               ewarn "the configure phase, either update your compiler or switch to <5.0 || >=5.4"
+       fi
+       if tc-is-gcc && [[ $(gcc-major-version) -eq 5 && $(gcc-minor-version) -eq 4 ]]; then
+               if has "-march=i686" ${CFLAGS} && ! has "-mtune=generic" ${CFLAGS}; then
+                       ewarn "Compilation can hang with CFLAGS=\"-march=i686\".  You can temporarily work"
+                       ewarn "around this by adding \"-mtune=generic\" to your CFLAGS for wine."
+                       ewarn "See package.env in man 5 portage for more information on how to do this."
+                       ewarn "See https://bugs.gentoo.org/show_bug.cgi?id=613128 for more details"
+               fi
+       fi
+
+       if use abi_x86_32 && use opencl && [[ "$(eselect opencl show 2> /dev/null)" == "intel" ]]; then
+               eerror "You cannot build wine with USE=opencl because intel-ocl-sdk is 64-bit only."
+               eerror "See https://bugs.gentoo.org/487864 for more details."
+               eerror
+               return 1
+       fi
+}
+
+wine_env_vcs_vars() {
+       local pn_live_var="${PN//[-+]/_}_LIVE_COMMIT"
+       local pn_live_val="${pn_live_var}"
+       eval pn_live_val='$'${pn_live_val}
+       if [[ ! -z ${pn_live_val} ]]; then
+               if use d3d9; then
+                       eerror "Because of the multi-repo nature of ${MY_PN}, ${pn_live_var}"
+                       eerror "cannot be used to set the commit. Instead, you may use the"
+                       eerror "environmental variables WINE_COMMIT, and D3D9_COMMIT."
+                       eerror
+                       return 1
+               fi
+       fi
+       if [[ ! -z ${EGIT_COMMIT} ]]; then
+               eerror "Commits must now be specified using the environmental variables"
+               eerror "WINE_COMMIT, and D3D9_COMMIT"
+               eerror
+               return 1
+       fi
+}
+
+pkg_pretend() {
+       wine_build_environment_check || die
+
+       # Verify OSS support
+       if use oss && ! use kernel_FreeBSD; then
+               if ! has_version ">=media-sound/oss-4"; then
+                       eerror "You cannot build wine with USE=oss without having support from a"
+                       eerror "FreeBSD kernel or >=media-sound/oss-4 (only available through external repos)"
+                       eerror
+                       die
+               fi
+       fi
+}
+
+pkg_setup() {
+       wine_build_environment_check || die
+       wine_env_vcs_vars || die
+
+       WINE_VARIANT="${PN#wine}-${PV}"
+       WINE_VARIANT="${WINE_VARIANT#-}"
+
+       MY_PREFIX="${EPREFIX}/usr/lib/wine-${WINE_VARIANT}"
+       MY_DATAROOTDIR="${EPREFIX}/usr/share/wine-${WINE_VARIANT}"
+       MY_DATADIR="${MY_DATAROOTDIR}"
+       MY_DOCDIR="${EPREFIX}/usr/share/doc/${PF}"
+       MY_INCLUDEDIR="${EPREFIX}/usr/include/wine-${WINE_VARIANT}"
+       MY_LIBEXECDIR="${EPREFIX}/usr/libexec/wine-${WINE_VARIANT}"
+       MY_LOCALSTATEDIR="${EPREFIX}/var/wine-${WINE_VARIANT}"
+       MY_MANDIR="${MY_DATADIR}/man"
+}
+
+src_unpack() {
+       if [[ ${PV} == "9999" ]] ; then
+               EGIT_CHECKOUT_DIR="${S}" EGIT_COMMIT="${WINE_COMMIT}" git-r3_src_unpack
+               if use d3d9; then
+                       git-r3_fetch "${D3D9_EGIT_REPO_URI}" "${D3D9_COMMIT}"
+                       git-r3_checkout "${D3D9_EGIT_REPO_URI}" "${D3D9_DIR}"
+               fi
+       fi
+
+       default
+
+       l10n_find_plocales_changes "${S}/po" "" ".po"
+}
+
+src_prepare() {
+
+       eapply_bin(){
+               local patch
+               for patch in ${PATCHES_BIN[@]}; do
+                       patchbin --nogit < "${patch}" || die
+               done
+       }
+
+       local md5="$(md5sum server/protocol.def)"
+
+       if use d3d9; then
+               PATCHES+=( "${D3D9_DIR}/d3d9-helper.patch" )
+               PATCHES+=( "${D3D9_DIR}/wine-d3d9.patch" )
+       fi
+
+       default
+       eapply_bin
+       eautoreconf
+
+       # Modification of the server protocol requires regenerating the server requests
+       if [[ "$(md5sum server/protocol.def)" != "${md5}" ]]; then
+               einfo "server/protocol.def was patched; running tools/make_requests"
+               tools/make_requests || die #432348
+       fi
+       sed -i '/^UPDATE_DESKTOP_DATABASE/s:=.*:=true:' tools/Makefile.in || die
+       if ! use run-exes; then
+               sed -i '/^MimeType/d' loader/wine.desktop || die #117785
+       fi
+
+       # Edit wine.desktop to work for specific variant
+       sed -e "/^Exec=/s/wine /wine-${WINE_VARIANT} /" -i loader/wine.desktop || die
+
+       # hi-res default icon, #472990, https://bugs.winehq.org/show_bug.cgi?id=24652
+       cp "${PATCHDIR}/files/oic_winlogo.ico" dlls/user32/resources/ || die
+
+       l10n_get_locales > po/LINGUAS || die # otherwise wine doesn't respect LINGUAS
+
+       # Fix manpage generation for locales #469418 and abi_x86_64 #617864
+       # Depends on wine-2.0-prevent-build-of-localized-manpages.patch"
+       # Duplicate manpages input for wine64
+       local man
+       for man in loader/*.man.in; do
+               cp ${man} ${man/wine/wine64} || die
+       done
+       # Add in proper manpages to Makefile
+       local search_text="wine.man.in"
+       if use abi_x86_64; then
+               sed -i "/${search_text}/i \
+                       "$'\\\t'"wine64.man.in "$'\\\\' loader/Makefile.in || die
+       fi
+       local l
+       for l in de fr pl; do
+               if has ${l} ${LINGUAS-${l}}; then
+                       sed -i "/${search_text}/i \
+                               "$'\\\t'"wine.${l}.UTF-8.man.in "$'\\\\' loader/Makefile.in || die
+                       if use abi_x86_64; then
+                               sed -i "/${search_text}/i \
+                                       "$'\\\t'"wine64.${l}.UTF-8.man.in "$'\\\\' loader/Makefile.in || die
+                       fi
+               fi
+       done
+}
+
+src_configure() {
+       wine_compiler_check || die
+
+       export LDCONFIG=/bin/true
+       use custom-cflags || strip-flags
+
+       multilib-minimal_src_configure
+}
+
+multilib_src_configure() {
+       local myconf=(
+               --prefix="${MY_PREFIX}"
+               --datarootdir="${MY_DATAROOTDIR}"
+               --datadir="${MY_DATADIR}"
+               --docdir="${MY_DOCDIR}"
+               --includedir="${MY_INCLUDEDIR}"
+               --libdir="${EPREFIX}/usr/$(get_libdir)/wine-${WINE_VARIANT}"
+               --libexecdir="${MY_LIBEXECDIR}"
+               --localstatedir="${MY_LOCALSTATEDIR}"
+               --mandir="${MY_MANDIR}"
+               --sysconfdir=/etc/wine
+               $(use_with alsa)
+               $(use_with capi)
+               $(use_with lcms cms)
+               $(use_with cups)
+               $(use_with ncurses curses)
+               $(use_with udisks dbus)
+               $(use_with fontconfig)
+               $(use_with ssl gnutls)
+               $(use_enable gecko mshtml)
+               $(use_with gphoto2 gphoto)
+               $(use_with gsm)
+               $(use_with gstreamer)
+               --without-hal
+               $(use_with jpeg)
+               $(use_with kerberos krb5)
+               $(use_with ldap)
+               $(use_enable mono mscoree)
+               $(use_with mp3 mpg123)
+               $(use_with netapi)
+               $(use_with nls gettext)
+               $(use_with openal)
+               $(use_with opencl)
+               $(use_with opengl)
+               $(use_with osmesa)
+               $(use_with oss)
+               $(use_with pcap)
+               $(use_with png)
+               $(use_with pulseaudio pulse)
+               $(use_with threads pthread)
+               $(use_with scanner sane)
+               $(use_enable test tests)
+               $(use_with truetype freetype)
+               $(use_with udev)
+               $(use_with v4l)
+               $(use_with X x)
+               $(use_with X xfixes)
+               $(use_with xcomposite)
+               $(use_with xinerama)
+               $(use_with xml)
+               $(use_with xml xslt)
+       )
+
+       use d3d9 && myconf+=( $(use_with d3d9 d3d9-nine) )
+
+       local PKG_CONFIG AR RANLIB
+       # Avoid crossdev's i686-pc-linux-gnu-pkg-config if building wine32 on amd64; #472038
+       # set AR and RANLIB to make QA scripts happy; #483342
+       tc-export PKG_CONFIG AR RANLIB
+
+       if use amd64; then
+               if [[ ${ABI} == amd64 ]]; then
+                       myconf+=( --enable-win64 )
+               else
+                       myconf+=( --disable-win64 )
+               fi
+
+               # Note: using --with-wine64 results in problems with multilib.eclass
+               # CC/LD hackery. We're using separate tools instead.
+       fi
+
+       ECONF_SOURCE=${S} \
+       econf "${myconf[@]}"
+       emake depend
+}
+
+multilib_src_test() {
+       # FIXME: win32-only; wine64 tests fail with "could not find the Wine loader"
+       if [[ ${ABI} == x86 ]]; then
+               if [[ $(id -u) == 0 ]]; then
+                       ewarn "Skipping tests since they cannot be run under the root user."
+                       ewarn "To run the test ${MY_PN} suite, add userpriv to FEATURES in make.conf"
+                       return
+               fi
+
+               WINEPREFIX="${T}/.wine-${ABI}" \
+               Xemake test
+       fi
+}
+
+multilib_src_install_all() {
+       local DOCS=( ANNOUNCE AUTHORS README )
+       add_locale_docs() {
+               local locale_doc="documentation/README.$1"
+               [[ ! -e ${locale_doc} ]] || DOCS+=( ${locale_doc} )
+       }
+       l10n_for_each_locale_do add_locale_docs
+
+       einstalldocs
+       prune_libtool_files --all
+
+       if ! use perl ; then # winedump calls function_grep.pl, and winemaker is a perl script
+               rm "${D%/}${MY_PREFIX}"/bin/{wine{dump,maker},function_grep.pl} \
+                       "${D%/}${MY_MANDIR}"/man1/wine{dump,maker}.1 || die
+       fi
+
+       # Remove wineconsole if neither backend is installed #551124
+       if ! use X && ! use ncurses; then
+               rm "${D%/}${MY_PREFIX}"/bin/wineconsole* || die
+               rm "${D%/}${MY_MANDIR}"/man1/wineconsole* || die
+               rm_wineconsole() {
+                       rm "${D%/}${MY_PREFIX}/$(get_libdir)"/wine/{,fakedlls/}wineconsole.exe* || die
+               }
+               multilib_foreach_abi rm_wineconsole
+       fi
+
+       use abi_x86_32 && pax-mark psmr "${D%/}${MY_PREFIX}"/bin/wine{,-preloader} #255055
+       use abi_x86_64 && pax-mark psmr "${D%/}${MY_PREFIX}"/bin/wine64{,-preloader}
+
+       if use abi_x86_64 && ! use abi_x86_32; then
+               dosym wine64 "${MY_PREFIX}"/bin/wine # 404331
+               dosym wine64-preloader "${MY_PREFIX}"/bin/wine-preloader
+       fi
+
+       # Failglob for bin and man loops
+       local glob_state=$(shopt -p failglob)
+       shopt -s failglob
+
+       # Make wrappers for binaries for handling multiple variants
+       # Note: wrappers instead of symlinks because some are shell which use basename
+       local b
+       for b in "${D%/}${MY_PREFIX}"/bin/*; do
+               make_wrapper "${b##*/}-${WINE_VARIANT}" "${MY_PREFIX}/bin/${b##*/}"
+       done
+}
+
+pkg_postinst() {
+       eselect wine register ${P}
+       if [[ ${PN} == "wine-vanilla" ]]; then
+               eselect wine register --vanilla ${P} || die
+       else
+               if use d3d9; then
+                       eselect wine register --d3d9 ${P} || die
+               fi
+       fi
+
+       eselect wine update --all --if-unset || die
+
+       xdg_desktop_database_update
+
+       if ! use gecko; then
+               ewarn "Without Wine Gecko, wine prefixes will not have a default"
+               ewarn "implementation of iexplore.  Many older windows applications"
+               ewarn "rely upon the existence of an iexplore implementation, so"
+               ewarn "you will likely need to install an external one, like via winetricks"
+       fi
+       if ! use mono; then
+               ewarn "Without Wine Mono, wine prefixes will not have a default"
+               ewarn "implementation of .NET.  Many windows applications rely upon"
+               ewarn "the existence of a .NET implementation, so you will likely need"
+               ewarn "to install an external one, like via winetricks"
+       fi
+}
+
+pkg_prerm() {
+       eselect wine deregister ${P}
+       if [[ ${PN} == "wine-vanilla" ]]; then
+               eselect wine deregister --vanilla ${P} || die
+       else
+               if use d3d9; then
+                       eselect wine deregister --d3d9 ${P} || die
+               fi
+       fi
+
+       eselect wine update --all --if-unset || die
+}
+
+pkg_postrm() {
+       xdg_desktop_database_update
+}
diff --git a/app-emulation/wine-d3d9/wine-d3d9-2.21.ebuild b/app-emulation/wine-d3d9/wine-d3d9-2.21.ebuild
new file mode 100644 (file)
index 0000000..7f16ff6
--- /dev/null
@@ -0,0 +1,588 @@
+# Copyright 1999-2018 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+PLOCALES="ar bg ca cs da de el en en_US eo es fa fi fr he hi hr hu it ja ko lt ml nb_NO nl or pa pl pt_BR pt_PT rm ro ru sk sl sr_RS@cyrillic sr_RS@latin sv te th tr uk wa zh_CN zh_TW"
+PLOCALE_BACKUP="en"
+
+inherit autotools eutils flag-o-matic gnome2-utils l10n multilib multilib-minimal pax-utils toolchain-funcs virtualx versionator xdg-utils
+
+MY_PN="${PN%%-*}"
+MY_P="${MY_PN}-${PV}"
+
+if [[ ${PV} == "9999" ]] ; then
+       EGIT_REPO_URI="https://source.winehq.org/git/wine.git"
+       EGIT_BRANCH="master"
+       inherit git-r3
+       SRC_URI=""
+       #KEYWORDS=""
+else
+       MAJOR_V=$(get_version_component_range 1)
+       SRC_URI="https://dl.winehq.org/wine/source/${MAJOR_V}.x/${MY_P}.tar.xz"
+       KEYWORDS="-* ~amd64 ~x86 ~x86-fbsd"
+fi
+S="${WORKDIR}/${MY_P}"
+
+D3D9_P="wine-d3d9-${PV}"
+D3D9_DIR="${WORKDIR}/wine-d3d9-patches-${D3D9_P}"
+GWP_V="20180119"
+PATCHDIR="${WORKDIR}/gentoo-wine-patches"
+
+DESCRIPTION="Free implementation of Windows(tm) on Unix, with Gallium Nine patchset"
+HOMEPAGE="https://www.winehq.org/"
+SRC_URI="${SRC_URI}
+       https://dev.gentoo.org/~np-hardass/distfiles/wine/gentoo-wine-patches-${GWP_V}.tar.xz
+"
+
+if [[ ${PV} == "9999" ]] ; then
+       D3D9_EGIT_REPO_URI="https://github.com/sarnex/wine-d3d9-patches.git"
+else
+       SRC_URI="${SRC_URI}
+       d3d9? ( https://github.com/sarnex/wine-d3d9-patches/archive/${D3D9_P}.tar.gz )"
+fi
+
+LICENSE="LGPL-2.1"
+SLOT="${PV}"
+IUSE="+abi_x86_32 +abi_x86_64 +alsa capi cups custom-cflags d3d9 dos elibc_glibc +fontconfig +gecko gphoto2 gsm gstreamer +jpeg kerberos kernel_FreeBSD +lcms ldap +mono mp3 ncurses netapi nls odbc openal opencl +opengl osmesa oss +perl pcap +png prelink pulseaudio +realtime +run-exes samba scanner selinux +ssl test +threads +truetype udev +udisks v4l +X +xcomposite xinerama +xml"
+REQUIRED_USE="|| ( abi_x86_32 abi_x86_64 )
+       X? ( truetype )
+       elibc_glibc? ( threads )
+       osmesa? ( opengl )
+       test? ( abi_x86_32 )" # osmesa-opengl #286560 # X-truetype #551124
+
+# FIXME: the test suite is unsuitable for us; many tests require net access
+# or fail due to Xvfb's opengl limitations.
+RESTRICT="test"
+
+COMMON_DEPEND="
+       X? (
+               x11-libs/libXcursor[${MULTILIB_USEDEP}]
+               x11-libs/libXext[${MULTILIB_USEDEP}]
+               x11-libs/libXfixes[${MULTILIB_USEDEP}]
+               x11-libs/libXrandr[${MULTILIB_USEDEP}]
+               x11-libs/libXi[${MULTILIB_USEDEP}]
+               x11-libs/libXxf86vm[${MULTILIB_USEDEP}]
+       )
+       alsa? ( media-libs/alsa-lib[${MULTILIB_USEDEP}] )
+       capi? ( net-libs/libcapi[${MULTILIB_USEDEP}] )
+       cups? ( net-print/cups:=[${MULTILIB_USEDEP}] )
+       d3d9? (
+               media-libs/mesa[d3d9,egl,${MULTILIB_USEDEP}]
+               x11-libs/libX11[${MULTILIB_USEDEP}]
+               x11-libs/libXext[${MULTILIB_USEDEP}]
+               x11-libs/libxcb[${MULTILIB_USEDEP}]
+       )
+       fontconfig? ( media-libs/fontconfig:=[${MULTILIB_USEDEP}] )
+       gphoto2? ( media-libs/libgphoto2:=[${MULTILIB_USEDEP}] )
+       gsm? ( media-sound/gsm:=[${MULTILIB_USEDEP}] )
+       gstreamer? (
+               media-libs/gstreamer:1.0[${MULTILIB_USEDEP}]
+               media-plugins/gst-plugins-meta:1.0[${MULTILIB_USEDEP}]
+       )
+       jpeg? ( virtual/jpeg:0=[${MULTILIB_USEDEP}] )
+       kerberos? ( virtual/krb5:0=[${MULTILIB_USEDEP}] )
+       lcms? ( media-libs/lcms:2=[${MULTILIB_USEDEP}] )
+       ldap? ( net-nds/openldap:=[${MULTILIB_USEDEP}] )
+       mp3? ( >=media-sound/mpg123-1.5.0[${MULTILIB_USEDEP}] )
+       ncurses? ( >=sys-libs/ncurses-5.2:0=[${MULTILIB_USEDEP}] )
+       netapi? ( net-fs/samba[netapi(+),${MULTILIB_USEDEP}] )
+       nls? ( sys-devel/gettext[${MULTILIB_USEDEP}] )
+       odbc? ( dev-db/unixODBC:=[${MULTILIB_USEDEP}] )
+       openal? ( media-libs/openal:=[${MULTILIB_USEDEP}] )
+       opencl? ( virtual/opencl[${MULTILIB_USEDEP}] )
+       opengl? (
+               virtual/glu[${MULTILIB_USEDEP}]
+               virtual/opengl[${MULTILIB_USEDEP}]
+       )
+       osmesa? ( >=media-libs/mesa-13[osmesa,${MULTILIB_USEDEP}] )
+       pcap? ( net-libs/libpcap[${MULTILIB_USEDEP}] )
+       png? ( media-libs/libpng:0=[${MULTILIB_USEDEP}] )
+       pulseaudio? ( media-sound/pulseaudio[${MULTILIB_USEDEP}] )
+       scanner? ( media-gfx/sane-backends:=[${MULTILIB_USEDEP}] )
+       ssl? ( net-libs/gnutls:=[${MULTILIB_USEDEP}] )
+       truetype? ( >=media-libs/freetype-2.0.0[${MULTILIB_USEDEP}] )
+       udev? ( virtual/libudev:=[${MULTILIB_USEDEP}] )
+       udisks? ( sys-apps/dbus[${MULTILIB_USEDEP}] )
+       v4l? ( media-libs/libv4l[${MULTILIB_USEDEP}] )
+       xcomposite? ( x11-libs/libXcomposite[${MULTILIB_USEDEP}] )
+       xinerama? ( x11-libs/libXinerama[${MULTILIB_USEDEP}] )
+       xml? (
+               dev-libs/libxml2[${MULTILIB_USEDEP}]
+               dev-libs/libxslt[${MULTILIB_USEDEP}]
+       )
+       abi_x86_32? (
+               !app-emulation/emul-linux-x86-baselibs[-abi_x86_32(-)]
+               !<app-emulation/emul-linux-x86-baselibs-20140508-r14
+               !app-emulation/emul-linux-x86-db[-abi_x86_32(-)]
+               !<app-emulation/emul-linux-x86-db-20140508-r3
+               !app-emulation/emul-linux-x86-medialibs[-abi_x86_32(-)]
+               !<app-emulation/emul-linux-x86-medialibs-20140508-r6
+               !app-emulation/emul-linux-x86-opengl[-abi_x86_32(-)]
+               !<app-emulation/emul-linux-x86-opengl-20140508-r1
+               !app-emulation/emul-linux-x86-sdl[-abi_x86_32(-)]
+               !<app-emulation/emul-linux-x86-sdl-20140508-r1
+               !app-emulation/emul-linux-x86-soundlibs[-abi_x86_32(-)]
+               !<app-emulation/emul-linux-x86-soundlibs-20140508
+               !app-emulation/emul-linux-x86-xlibs[-abi_x86_32(-)]
+               !<app-emulation/emul-linux-x86-xlibs-20140508
+       )"
+
+RDEPEND="${COMMON_DEPEND}
+       app-emulation/wine-desktop-common
+       >app-eselect/eselect-wine-0.3
+       !app-emulation/wine:0
+       dos? ( >=games-emulation/dosbox-0.74_p20160629 )
+       gecko? ( app-emulation/wine-gecko:2.47[abi_x86_32?,abi_x86_64?] )
+       mono? ( app-emulation/wine-mono:4.7.1 )
+       perl? (
+               dev-lang/perl
+               dev-perl/XML-Simple
+       )
+       pulseaudio? (
+               realtime? ( sys-auth/rtkit )
+       )
+       samba? ( >=net-fs/samba-3.0.25[winbind] )
+       selinux? ( sec-policy/selinux-wine )
+       udisks? ( sys-fs/udisks:2 )"
+
+# tools/make_requests requires perl
+DEPEND="${COMMON_DEPEND}
+       sys-devel/flex
+       >=sys-kernel/linux-headers-2.6
+       virtual/pkgconfig
+       virtual/yacc
+       X? (
+               x11-proto/inputproto
+               x11-proto/xextproto
+               x11-proto/xf86vidmodeproto
+       )
+       prelink? ( sys-devel/prelink )
+       xinerama? ( x11-proto/xineramaproto )"
+
+# These use a non-standard "Wine" category, which is provided by
+# /etc/xdg/applications-merged/wine.menu
+QA_DESKTOP_FILE="usr/share/applications/wine-browsedrive.desktop
+usr/share/applications/wine-notepad.desktop
+usr/share/applications/wine-uninstaller.desktop
+usr/share/applications/wine-winecfg.desktop"
+
+PATCHES=(
+       "${PATCHDIR}/patches/${MY_PN}-1.5.26-winegcc.patch" #260726
+       "${PATCHDIR}/patches/${MY_PN}-1.9.5-multilib-portage.patch" #395615
+       "${PATCHDIR}/patches/${MY_PN}-1.6-memset-O3.patch" #480508
+       "${PATCHDIR}/patches/${MY_PN}-2.0-multislot-apploader.patch" #310611
+       "${PATCHDIR}/patches/${MY_PN}-2.0-prevent-build-of-localized-manpages.patch" #469418 #617864
+)
+PATCHES_BIN=()
+
+# https://bugs.gentoo.org/show_bug.cgi?id=635222
+if [[ ${#PATCHES_BIN[@]} -ge 1 ]] || [[ ${PV} == 9999 ]]; then
+       DEPEND+=" dev-util/patchbin"
+fi
+
+wine_compiler_check() {
+       [[ ${MERGE_TYPE} = "binary" ]] && return 0
+
+       # GCC-specific bugs
+       if tc-is-gcc; then
+               # bug #549768
+               if use abi_x86_64 && [[ $(gcc-major-version) = 5 && $(gcc-minor-version) -le 2 ]]; then
+                       ebegin "Checking for gcc-5 ms_abi compiler bug"
+                       $(tc-getCC) -O2 "${PATCHDIR}/files/pr66838.c" -o "${T}"/pr66838 || die
+                       # Run in subshell to prevent "Aborted" message
+                       ( "${T}"/pr66838 || false ) >/dev/null 2>&1
+                       if ! eend $?; then
+                               eerror "64-bit wine cannot be built with gcc-5.1 or initial patchset of 5.2.0"
+                               eerror "due to compiler bugs; please re-emerge the latest gcc-5.2.x ebuild,"
+                               eerror "or use gcc-config to select a different compiler version."
+                               eerror "See https://bugs.gentoo.org/549768"
+                               eerror
+                               return 1
+                       fi
+               fi
+               # bug #574044
+               if use abi_x86_64 && [[ $(gcc-major-version) = 5 && $(gcc-minor-version) = 3 ]]; then
+                       ebegin "Checking for gcc-5-3 stack realignment compiler bug"
+                       # Compile in subshell to prevent "Aborted" message
+                       ( $(tc-getCC) -O2 -mincoming-stack-boundary=3 "${PATCHDIR}/files/pr69140.c" -o "${T}"/pr69140 ) >/dev/null 2>&1
+                       if ! eend $?; then
+                               eerror "Wine cannot be built with this version of gcc-5.3"
+                               eerror "due to compiler bugs; please re-emerge the latest gcc-5.3.x ebuild,"
+                               eerror "or use gcc-config to select a different compiler version."
+                               eerror "See https://bugs.gentoo.org/574044"
+                               eerror
+                               return 1
+                       fi
+               fi
+       fi
+
+       # Ensure compiler support
+       if use abi_x86_64; then
+               ebegin "Checking for 64-bit compiler with builtin_ms_va_list support"
+               # Compile in subshell to prevent "Aborted" message
+               ( $(tc-getCC) -O2 "${PATCHDIR}/files/builtin_ms_va_list.c" -o "${T}"/builtin_ms_va_list >/dev/null 2>&1)
+               if ! eend $?; then
+                       eerror "This version of $(tc-getCC) does not support builtin_ms_va_list, can't enable 64-bit wine"
+                       eerror
+                       eerror "You need gcc-4.4+ or clang 3.8+ to build 64-bit wine"
+                       eerror
+                       return 1
+               fi
+       fi
+}
+
+wine_build_environment_check() {
+       [[ ${MERGE_TYPE} = "binary" ]] && return 0
+
+       if use abi_x86_64; then
+               if tc-is-gcc && [[ $(gcc-major-version) -lt 4 || ( $(gcc-major-version) -eq 4 && $(gcc-minor-version) -lt 4 ) ]]; then
+                       eerror "You need gcc-4.4+ to compile 64-bit wine"
+                       die
+               elif tc-is-clang && [[ $(clang-major-version) -lt 3 || ( $(clang-major-version) -eq 3 && $(clang-minor-version) -lt 8 ) ]]; then
+                       eerror "You need clang-3.8+ to compile 64-bit wine"
+                       die
+               fi
+       fi
+       if tc-is-gcc && [[ $(gcc-major-version) -eq 5 && $(gcc-minor-version) -le 3 ]]; then
+               ewarn "GCC-5.0-5.3 suffered from compiler bugs and are no longer supported by"
+               ewarn "Gentoo's Toolchain Team. If your ebuild fails the compiler checks in"
+               ewarn "the configure phase, either update your compiler or switch to <5.0 || >=5.4"
+       fi
+       if tc-is-gcc && [[ $(gcc-major-version) -eq 5 && $(gcc-minor-version) -eq 4 ]]; then
+               if has "-march=i686" ${CFLAGS} && ! has "-mtune=generic" ${CFLAGS}; then
+                       ewarn "Compilation can hang with CFLAGS=\"-march=i686\".  You can temporarily work"
+                       ewarn "around this by adding \"-mtune=generic\" to your CFLAGS for wine."
+                       ewarn "See package.env in man 5 portage for more information on how to do this."
+                       ewarn "See https://bugs.gentoo.org/show_bug.cgi?id=613128 for more details"
+               fi
+       fi
+
+       if use abi_x86_32 && use opencl && [[ "$(eselect opencl show 2> /dev/null)" == "intel" ]]; then
+               eerror "You cannot build wine with USE=opencl because intel-ocl-sdk is 64-bit only."
+               eerror "See https://bugs.gentoo.org/487864 for more details."
+               eerror
+               return 1
+       fi
+}
+
+wine_env_vcs_vars() {
+       local pn_live_var="${PN//[-+]/_}_LIVE_COMMIT"
+       local pn_live_val="${pn_live_var}"
+       eval pn_live_val='$'${pn_live_val}
+       if [[ ! -z ${pn_live_val} ]]; then
+               if use d3d9; then
+                       eerror "Because of the multi-repo nature of ${MY_PN}, ${pn_live_var}"
+                       eerror "cannot be used to set the commit. Instead, you may use the"
+                       eerror "environmental variables WINE_COMMIT, and D3D9_COMMIT."
+                       eerror
+                       return 1
+               fi
+       fi
+       if [[ ! -z ${EGIT_COMMIT} ]]; then
+               eerror "Commits must now be specified using the environmental variables"
+               eerror "WINE_COMMIT, and D3D9_COMMIT"
+               eerror
+               return 1
+       fi
+}
+
+pkg_pretend() {
+       wine_build_environment_check || die
+
+       # Verify OSS support
+       if use oss && ! use kernel_FreeBSD; then
+               if ! has_version ">=media-sound/oss-4"; then
+                       eerror "You cannot build wine with USE=oss without having support from a"
+                       eerror "FreeBSD kernel or >=media-sound/oss-4 (only available through external repos)"
+                       eerror
+                       die
+               fi
+       fi
+}
+
+pkg_setup() {
+       wine_build_environment_check || die
+       wine_env_vcs_vars || die
+
+       WINE_VARIANT="${PN#wine}-${PV}"
+       WINE_VARIANT="${WINE_VARIANT#-}"
+
+       MY_PREFIX="${EPREFIX}/usr/lib/wine-${WINE_VARIANT}"
+       MY_DATAROOTDIR="${EPREFIX}/usr/share/wine-${WINE_VARIANT}"
+       MY_DATADIR="${MY_DATAROOTDIR}"
+       MY_DOCDIR="${EPREFIX}/usr/share/doc/${PF}"
+       MY_INCLUDEDIR="${EPREFIX}/usr/include/wine-${WINE_VARIANT}"
+       MY_LIBEXECDIR="${EPREFIX}/usr/libexec/wine-${WINE_VARIANT}"
+       MY_LOCALSTATEDIR="${EPREFIX}/var/wine-${WINE_VARIANT}"
+       MY_MANDIR="${MY_DATADIR}/man"
+}
+
+src_unpack() {
+       if [[ ${PV} == "9999" ]] ; then
+               EGIT_CHECKOUT_DIR="${S}" EGIT_COMMIT="${WINE_COMMIT}" git-r3_src_unpack
+               if use d3d9; then
+                       git-r3_fetch "${D3D9_EGIT_REPO_URI}" "${D3D9_COMMIT}"
+                       git-r3_checkout "${D3D9_EGIT_REPO_URI}" "${D3D9_DIR}"
+               fi
+       fi
+
+       default
+
+       l10n_find_plocales_changes "${S}/po" "" ".po"
+}
+
+src_prepare() {
+
+       eapply_bin(){
+               local patch
+               for patch in ${PATCHES_BIN[@]}; do
+                       patchbin --nogit < "${patch}" || die
+               done
+       }
+
+       local md5="$(md5sum server/protocol.def)"
+
+       if use d3d9; then
+               PATCHES+=( "${D3D9_DIR}/d3d9-helper.patch" )
+               PATCHES+=( "${D3D9_DIR}/wine-d3d9.patch" )
+       fi
+
+       default
+       eapply_bin
+       eautoreconf
+
+       # Modification of the server protocol requires regenerating the server requests
+       if [[ "$(md5sum server/protocol.def)" != "${md5}" ]]; then
+               einfo "server/protocol.def was patched; running tools/make_requests"
+               tools/make_requests || die #432348
+       fi
+       sed -i '/^UPDATE_DESKTOP_DATABASE/s:=.*:=true:' tools/Makefile.in || die
+       if ! use run-exes; then
+               sed -i '/^MimeType/d' loader/wine.desktop || die #117785
+       fi
+
+       # Edit wine.desktop to work for specific variant
+       sed -e "/^Exec=/s/wine /wine-${WINE_VARIANT} /" -i loader/wine.desktop || die
+
+       # hi-res default icon, #472990, https://bugs.winehq.org/show_bug.cgi?id=24652
+       cp "${PATCHDIR}/files/oic_winlogo.ico" dlls/user32/resources/ || die
+
+       l10n_get_locales > po/LINGUAS || die # otherwise wine doesn't respect LINGUAS
+
+       # Fix manpage generation for locales #469418 and abi_x86_64 #617864
+       # Depends on wine-2.0-prevent-build-of-localized-manpages.patch"
+       # Duplicate manpages input for wine64
+       local man
+       for man in loader/*.man.in; do
+               cp ${man} ${man/wine/wine64} || die
+       done
+       # Add in proper manpages to Makefile
+       local search_text="wine.man.in"
+       if use abi_x86_64; then
+               sed -i "/${search_text}/i \
+                       "$'\\\t'"wine64.man.in "$'\\\\' loader/Makefile.in || die
+       fi
+       local l
+       for l in de fr pl; do
+               if has ${l} ${LINGUAS-${l}}; then
+                       sed -i "/${search_text}/i \
+                               "$'\\\t'"wine.${l}.UTF-8.man.in "$'\\\\' loader/Makefile.in || die
+                       if use abi_x86_64; then
+                               sed -i "/${search_text}/i \
+                                       "$'\\\t'"wine64.${l}.UTF-8.man.in "$'\\\\' loader/Makefile.in || die
+                       fi
+               fi
+       done
+}
+
+src_configure() {
+       wine_compiler_check || die
+
+       export LDCONFIG=/bin/true
+       use custom-cflags || strip-flags
+
+       multilib-minimal_src_configure
+}
+
+multilib_src_configure() {
+       local myconf=(
+               --prefix="${MY_PREFIX}"
+               --datarootdir="${MY_DATAROOTDIR}"
+               --datadir="${MY_DATADIR}"
+               --docdir="${MY_DOCDIR}"
+               --includedir="${MY_INCLUDEDIR}"
+               --libdir="${EPREFIX}/usr/$(get_libdir)/wine-${WINE_VARIANT}"
+               --libexecdir="${MY_LIBEXECDIR}"
+               --localstatedir="${MY_LOCALSTATEDIR}"
+               --mandir="${MY_MANDIR}"
+               --sysconfdir=/etc/wine
+               $(use_with alsa)
+               $(use_with capi)
+               $(use_with lcms cms)
+               $(use_with cups)
+               $(use_with ncurses curses)
+               $(use_with udisks dbus)
+               $(use_with fontconfig)
+               $(use_with ssl gnutls)
+               $(use_enable gecko mshtml)
+               $(use_with gphoto2 gphoto)
+               $(use_with gsm)
+               $(use_with gstreamer)
+               --without-hal
+               $(use_with jpeg)
+               $(use_with kerberos krb5)
+               $(use_with ldap)
+               $(use_enable mono mscoree)
+               $(use_with mp3 mpg123)
+               $(use_with netapi)
+               $(use_with nls gettext)
+               $(use_with openal)
+               $(use_with opencl)
+               $(use_with opengl)
+               $(use_with osmesa)
+               $(use_with oss)
+               $(use_with pcap)
+               $(use_with png)
+               $(use_with pulseaudio pulse)
+               $(use_with threads pthread)
+               $(use_with scanner sane)
+               $(use_enable test tests)
+               $(use_with truetype freetype)
+               $(use_with udev)
+               $(use_with v4l)
+               $(use_with X x)
+               $(use_with X xfixes)
+               $(use_with xcomposite)
+               $(use_with xinerama)
+               $(use_with xml)
+               $(use_with xml xslt)
+       )
+
+       use d3d9 && myconf+=( $(use_with d3d9 d3d9-nine) )
+
+       local PKG_CONFIG AR RANLIB
+       # Avoid crossdev's i686-pc-linux-gnu-pkg-config if building wine32 on amd64; #472038
+       # set AR and RANLIB to make QA scripts happy; #483342
+       tc-export PKG_CONFIG AR RANLIB
+
+       if use amd64; then
+               if [[ ${ABI} == amd64 ]]; then
+                       myconf+=( --enable-win64 )
+               else
+                       myconf+=( --disable-win64 )
+               fi
+
+               # Note: using --with-wine64 results in problems with multilib.eclass
+               # CC/LD hackery. We're using separate tools instead.
+       fi
+
+       ECONF_SOURCE=${S} \
+       econf "${myconf[@]}"
+       emake depend
+}
+
+multilib_src_test() {
+       # FIXME: win32-only; wine64 tests fail with "could not find the Wine loader"
+       if [[ ${ABI} == x86 ]]; then
+               if [[ $(id -u) == 0 ]]; then
+                       ewarn "Skipping tests since they cannot be run under the root user."
+                       ewarn "To run the test ${MY_PN} suite, add userpriv to FEATURES in make.conf"
+                       return
+               fi
+
+               WINEPREFIX="${T}/.wine-${ABI}" \
+               Xemake test
+       fi
+}
+
+multilib_src_install_all() {
+       local DOCS=( ANNOUNCE AUTHORS README )
+       add_locale_docs() {
+               local locale_doc="documentation/README.$1"
+               [[ ! -e ${locale_doc} ]] || DOCS+=( ${locale_doc} )
+       }
+       l10n_for_each_locale_do add_locale_docs
+
+       einstalldocs
+       prune_libtool_files --all
+
+       if ! use perl ; then # winedump calls function_grep.pl, and winemaker is a perl script
+               rm "${D%/}${MY_PREFIX}"/bin/{wine{dump,maker},function_grep.pl} \
+                       "${D%/}${MY_MANDIR}"/man1/wine{dump,maker}.1 || die
+       fi
+
+       # Remove wineconsole if neither backend is installed #551124
+       if ! use X && ! use ncurses; then
+               rm "${D%/}${MY_PREFIX}"/bin/wineconsole* || die
+               rm "${D%/}${MY_MANDIR}"/man1/wineconsole* || die
+               rm_wineconsole() {
+                       rm "${D%/}${MY_PREFIX}/$(get_libdir)"/wine/{,fakedlls/}wineconsole.exe* || die
+               }
+               multilib_foreach_abi rm_wineconsole
+       fi
+
+       use abi_x86_32 && pax-mark psmr "${D%/}${MY_PREFIX}"/bin/wine{,-preloader} #255055
+       use abi_x86_64 && pax-mark psmr "${D%/}${MY_PREFIX}"/bin/wine64{,-preloader}
+
+       if use abi_x86_64 && ! use abi_x86_32; then
+               dosym wine64 "${MY_PREFIX}"/bin/wine # 404331
+               dosym wine64-preloader "${MY_PREFIX}"/bin/wine-preloader
+       fi
+
+       # Failglob for bin and man loops
+       local glob_state=$(shopt -p failglob)
+       shopt -s failglob
+
+       # Make wrappers for binaries for handling multiple variants
+       # Note: wrappers instead of symlinks because some are shell which use basename
+       local b
+       for b in "${D%/}${MY_PREFIX}"/bin/*; do
+               make_wrapper "${b##*/}-${WINE_VARIANT}" "${MY_PREFIX}/bin/${b##*/}"
+       done
+}
+
+pkg_postinst() {
+       eselect wine register ${P}
+       if [[ ${PN} == "wine-vanilla" ]]; then
+               eselect wine register --vanilla ${P} || die
+       else
+               if use d3d9; then
+                       eselect wine register --d3d9 ${P} || die
+               fi
+       fi
+
+       eselect wine update --all --if-unset || die
+
+       xdg_desktop_database_update
+
+       if ! use gecko; then
+               ewarn "Without Wine Gecko, wine prefixes will not have a default"
+               ewarn "implementation of iexplore.  Many older windows applications"
+               ewarn "rely upon the existence of an iexplore implementation, so"
+               ewarn "you will likely need to install an external one, like via winetricks"
+       fi
+       if ! use mono; then
+               ewarn "Without Wine Mono, wine prefixes will not have a default"
+               ewarn "implementation of .NET.  Many windows applications rely upon"
+               ewarn "the existence of a .NET implementation, so you will likely need"
+               ewarn "to install an external one, like via winetricks"
+       fi
+}
+
+pkg_prerm() {
+       eselect wine deregister ${P}
+       if [[ ${PN} == "wine-vanilla" ]]; then
+               eselect wine deregister --vanilla ${P} || die
+       else
+               if use d3d9; then
+                       eselect wine deregister --d3d9 ${P} || die
+               fi
+       fi
+
+       eselect wine update --all --if-unset || die
+}
+
+pkg_postrm() {
+       xdg_desktop_database_update
+}
index 27e42238117980ad4049abe48d9bae1b5c1dcca8..7f16ff60d60036380400a3ac45ec57d91aea253c 100644 (file)
@@ -26,7 +26,7 @@ S="${WORKDIR}/${MY_P}"
 
 D3D9_P="wine-d3d9-${PV}"
 D3D9_DIR="${WORKDIR}/wine-d3d9-patches-${D3D9_P}"
-GWP_V="20170830"
+GWP_V="20180119"
 PATCHDIR="${WORKDIR}/gentoo-wine-patches"
 
 DESCRIPTION="Free implementation of Windows(tm) on Unix, with Gallium Nine patchset"
@@ -44,7 +44,7 @@ fi
 
 LICENSE="LGPL-2.1"
 SLOT="${PV}"
-IUSE="+abi_x86_32 +abi_x86_64 +alsa capi cups custom-cflags d3d9 dos elibc_glibc +fontconfig +gecko gphoto2 gsm gstreamer +jpeg kernel_FreeBSD +lcms ldap +mono mp3 ncurses netapi nls odbc openal opencl +opengl osmesa oss +perl pcap +png prelink pulseaudio +realtime +run-exes samba scanner selinux +ssl test +threads +truetype udev +udisks v4l +X +xcomposite xinerama +xml"
+IUSE="+abi_x86_32 +abi_x86_64 +alsa capi cups custom-cflags d3d9 dos elibc_glibc +fontconfig +gecko gphoto2 gsm gstreamer +jpeg kerberos kernel_FreeBSD +lcms ldap +mono mp3 ncurses netapi nls odbc openal opencl +opengl osmesa oss +perl pcap +png prelink pulseaudio +realtime +run-exes samba scanner selinux +ssl test +threads +truetype udev +udisks v4l +X +xcomposite xinerama +xml"
 REQUIRED_USE="|| ( abi_x86_32 abi_x86_64 )
        X? ( truetype )
        elibc_glibc? ( threads )
@@ -81,6 +81,7 @@ COMMON_DEPEND="
                media-plugins/gst-plugins-meta:1.0[${MULTILIB_USEDEP}]
        )
        jpeg? ( virtual/jpeg:0=[${MULTILIB_USEDEP}] )
+       kerberos? ( virtual/krb5:0=[${MULTILIB_USEDEP}] )
        lcms? ( media-libs/lcms:2=[${MULTILIB_USEDEP}] )
        ldap? ( net-nds/openldap:=[${MULTILIB_USEDEP}] )
        mp3? ( >=media-sound/mpg123-1.5.0[${MULTILIB_USEDEP}] )
@@ -170,7 +171,8 @@ PATCHES=(
        "${PATCHDIR}/patches/${MY_PN}-1.5.26-winegcc.patch" #260726
        "${PATCHDIR}/patches/${MY_PN}-1.9.5-multilib-portage.patch" #395615
        "${PATCHDIR}/patches/${MY_PN}-1.6-memset-O3.patch" #480508
-       "${PATCHDIR}/patches/${MY_PN}-2.0-multislot-apploader.patch"
+       "${PATCHDIR}/patches/${MY_PN}-2.0-multislot-apploader.patch" #310611
+       "${PATCHDIR}/patches/${MY_PN}-2.0-prevent-build-of-localized-manpages.patch" #469418 #617864
 )
 PATCHES_BIN=()
 
@@ -367,6 +369,31 @@ src_prepare() {
        cp "${PATCHDIR}/files/oic_winlogo.ico" dlls/user32/resources/ || die
 
        l10n_get_locales > po/LINGUAS || die # otherwise wine doesn't respect LINGUAS
+
+       # Fix manpage generation for locales #469418 and abi_x86_64 #617864
+       # Depends on wine-2.0-prevent-build-of-localized-manpages.patch"
+       # Duplicate manpages input for wine64
+       local man
+       for man in loader/*.man.in; do
+               cp ${man} ${man/wine/wine64} || die
+       done
+       # Add in proper manpages to Makefile
+       local search_text="wine.man.in"
+       if use abi_x86_64; then
+               sed -i "/${search_text}/i \
+                       "$'\\\t'"wine64.man.in "$'\\\\' loader/Makefile.in || die
+       fi
+       local l
+       for l in de fr pl; do
+               if has ${l} ${LINGUAS-${l}}; then
+                       sed -i "/${search_text}/i \
+                               "$'\\\t'"wine.${l}.UTF-8.man.in "$'\\\\' loader/Makefile.in || die
+                       if use abi_x86_64; then
+                               sed -i "/${search_text}/i \
+                                       "$'\\\t'"wine64.${l}.UTF-8.man.in "$'\\\\' loader/Makefile.in || die
+                       fi
+               fi
+       done
 }
 
 src_configure() {
@@ -404,6 +431,7 @@ multilib_src_configure() {
                $(use_with gstreamer)
                --without-hal
                $(use_with jpeg)
+               $(use_with kerberos krb5)
                $(use_with ldap)
                $(use_enable mono mscoree)
                $(use_with mp3 mpg123)
@@ -512,14 +540,6 @@ multilib_src_install_all() {
        for b in "${D%/}${MY_PREFIX}"/bin/*; do
                make_wrapper "${b##*/}-${WINE_VARIANT}" "${MY_PREFIX}/bin/${b##*/}"
        done
-
-       # respect LINGUAS when installing man pages, #469418
-       local l
-       for l in de fr pl; do
-               has ${l} ${LINGUAS-${l}} || rm -rf "${D%/}${MY_MANDIR}"/${l}*
-       done
-
-       eval "${glob_state}"
 }
 
 pkg_postinst() {